<template>
  <v-container class="pa-0">
    <v-row v-if="isAdmin">
      <v-col cols="12">
        <v-alert dense dark color="red darken-3" icon="mdi-alert" class="mb-0">
          You are an admin on this instance with write access to all groups and projects, please exercise caution when using this feature.
        </v-alert>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat>
          <v-card-title class="text-h5">Import Project Framework Assignments</v-card-title>
          <v-card-subtitle>Upload an audit sheet to assign frameworks to projects</v-card-subtitle>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat>
          <v-card-title>Select Import Sheet</v-card-title>
          <v-card-subtitle>Audit reports and undo sheets are supported</v-card-subtitle>
          <v-data-table :items="rawProjectEntries" :headers="importHeader" v-if="rawProjectEntries.length > 0" dense>
          </v-data-table>
          <div v-else>
            <v-card-text class="pt-0">
              <form enctype="multipart/form-data" novalidate>
                <div class="dropbox">
                  <input type="file" :name="'document'" multiple="false" @change="onUpload" class="input-file">
                  <p>
                    Drag and drop Excel file here<br> or click to browse
                  </p>
                </div>
              </form>
            </v-card-text>
          </div>
          <v-card-actions v-if="importedEntries.length > 0">
            <v-spacer/>
            <v-btn @click.native="init"
              small
              depressed>Clear</v-btn>
            <v-btn
              color="primary"
              small
              depressed
              :disabled="loadingPreview"
              @click.native="previewChanges"
            >Preview</v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat v-if="loadingPreview">
          <v-card-title class="pa-10">
            <v-spacer></v-spacer><Tanuki :loading="true" size="150"></Tanuki><v-spacer></v-spacer>
          </v-card-title>
        </v-card>
        <v-card v-if="!loadingPreview && (projectsInScope != null && projectsInScope.length > 0)" flat>
          <v-card-title>
            Change Preview
            <v-spacer></v-spacer>
            <v-switch dense hide-details inset class="ma-0 pa-0" label="Hide Unchanged" v-model="hideUnchanged"></v-switch>
          </v-card-title>
          <PreviewProjectChanges :data="changePreview"></PreviewProjectChanges>
          <v-card-actions>
            <v-spacer/>
            <v-btn
              color="primary"
              depressed
              small
              :disabled="!hasChanges || isCommitting"
              @click.native="commitChanges"
            >{{ hasChanges ? 'Apply Changes' : 'No Changes' }}</v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat v-if="isCommitting">
          <v-card-title class="pa-10">
            <v-spacer></v-spacer><Tanuki :loading="true" size="150"></Tanuki><v-spacer></v-spacer>
          </v-card-title>
        </v-card>
        <ProjectUpdateResults
        v-if="!isCommitting && commitResults.length > 0"
        :results="commitResults"
        ></ProjectUpdateResults>
      </v-col>
    </v-row>
  </v-container>
</template>

<style>
.dropbox {
    outline: 2px dashed lightgrey; /* the dash box */
  outline-offset: -10px;
  background: transparent;
  color: dimgray;
  padding: 10px 10px;
    min-height: 200px; /* minimum height */
  position: relative;
  cursor: pointer;
}

.input-file {
    opacity: 0; /* invisible but it's there! */
  width: 100%;
  height: 200px;
  position: absolute;
  cursor: pointer;
}

.dropbox:hover {
    background: rgba(255,255,255,0.1); /* when mouse over to the drop zone, change color */
}

.dropbox p {
  font-size: 1.2em;
  text-align: center;
  padding: 50px 0;
}
</style>

<script lang="ts">
import { Component, Mixins, Watch } from 'vue-property-decorator'
import { Getter } from 'vuex-class'
import GroupTable from '../components/GroupTable.vue'
import Tanuki from '../components/Tanuki.vue'
import * as Excel from 'xlsx'
import * as Mutations from '../lib/graphql_mutations'
import ApiAccess from '@/mixins/apiAccess'
import ProjectUpdateResults from '../components/ProjectUpdateResults.vue'
import PreviewProjectChanges from '../components/PreviewProjectChanges.vue'

@Component({
  components: { GroupTable, Tanuki, ProjectUpdateResults, PreviewProjectChanges }
})
export default class ImportProjectAssignments extends Mixins(ApiAccess) {
  @Getter isAdmin!: boolean

  importedEntries: any[] = []
  rawProjectEntries: any[] = []
  rawFrameworkEntries: any[] = []
  loadingPreview = false
  projectsInScope: any[] = []
  isUndoSheet = false
  isCommitting = false
  loadingProjects = false
  hideUnchanged = false
  commitResults: any[] = []
  showOnlyErrors = false

  getFrameworkByName (frameworks: any[], name: string): any {
    return frameworks.find((framework: any) => framework.name === name)
  }

  get frameworksByName (): any {
    const frameworks: any = {}
    this.rawFrameworkEntries.map((entry) => {
      frameworks[entry.Name] = entry.ID
    })

    return frameworks
  }

  get importHeader (): any {
    return ['Name', 'Path', 'Compliance Framework'].map((key) => {
      return { text: key, value: key }
    })
  }

  onUpload (evt: any): void {
    // Load excel sheet
    // Parse entry data based on columns
    this.importedEntries = []
    this.rawProjectEntries = []
    this.rawFrameworkEntries = []
    const files = evt.target.files
    if (!files || files.length === 0) return
    const file = files[0]

    var reader = new FileReader()
    reader.onload = (evt) => {
      const workbook = Excel.read(evt?.target?.result)
      let projectSheet: any = null
      if (workbook.Sheets.Projects) {
        projectSheet = workbook.Sheets.Projects
      } else if (workbook.Sheets['Undo Sheet']) {
        projectSheet = workbook.Sheets['Undo Sheet']
        this.isUndoSheet = true
      }
      const frameworkSheet = workbook.Sheets['Compliance Frameworks']
      this.rawFrameworkEntries = Excel.utils.sheet_to_json(frameworkSheet)
      this.rawProjectEntries = Excel.utils.sheet_to_json(projectSheet)

      this.rawProjectEntries.forEach((row: any) => {
        const entry = {
          projectId: row.ID,
          frameworkName: row['Compliance Framework']?.trim() ?? ''
        }

        this.importedEntries.push(entry)
      })
    }
    reader.readAsArrayBuffer(file)
  }

  async previewChanges (): Promise<void> {
    this.loadingPreview = true
    this.projectsInScope = []
    await Promise.all(this.importedEntries.map(async (entry) => {
      const project = await this.getProjectbyID(entry.projectId)
      console.log(project)
      const groupFrameworks = await this.getFrameworksForProject(project)
      const newFrameworkName = entry.frameworkName
      const newFramework = newFrameworkName !== '' ? this.getFrameworkByName(groupFrameworks, newFrameworkName) : null
      console.log('New Framework: ' + newFrameworkName)
      console.log(newFramework)

      const projectPreview: any = {
        id: project.id,
        name: project.name,
        path: project.path_with_namespace,
        description: project.description,
        webUrl: project.web_url,
        hasComplianceFramework: false
      }
      const complianceFrameworks = project.compliance_frameworks
      if (complianceFrameworks) {
        const framework = this.getFrameworkByName(groupFrameworks, complianceFrameworks[0])
        if (framework) {
          projectPreview.complianceFramework = framework
          projectPreview.hasComplianceFramework = true
        }
      }

      // add changed framework info
      projectPreview.newComplianceFramework = newFramework
      if (!projectPreview.hasComplianceFramework) {
        projectPreview.complianceChanged = projectPreview.newComplianceFramework != null
      } else {
        projectPreview.complianceChanged = projectPreview.newComplianceFramework == null || projectPreview.complianceFramework.id !== projectPreview.newComplianceFramework.id
      }

      // push to array
      this.projectsInScope.push(projectPreview)
    }))

    this.loadingPreview = false
  }

  getProposedChanges (): any {
    // Iterate entry data imported from the sheet
    // For each entry, check whether its compliance framework is different than its corresponding project on the instance
  }

  get hasChanges (): boolean {
    return this.changePreview.filter((entry: any) => entry.complianceChanged).length > 0
  }

  get changePreview (): any {
    return this.projectsInScope.filter((project: any) => !this.hideUnchanged || project.complianceChanged)
  }

  commitProgress:any = {}

  @Watch('commitResults', { deep: true })
  updateCommitProgress (): any {
    const totalChanges = this.commitableChanges.length
    let success = 0
    let errors = 0
    this.commitResults.forEach((result) => {
      if (result.isSuccess) {
        success++
      } else {
        errors++
      }
    })

    this.commitProgress = {
      total: totalChanges,
      success,
      errors,
      remaining: totalChanges - errors - success
    }
  }

  get commitChartData (): any {
    const data = {
      labels: ['Success', 'Errors', 'Remaining'],
      datasets: [{
        backgroundColor: ['green', 'red', 'white'],
        data: [this.commitProgress.success, this.commitProgress.errors, this.commitProgress.remaining]
      }]
    }

    console.log(data)
    return data
  }

  get commitableChanges (): any {
    return this.changePreview.filter((entry: any) => entry.complianceChanged)
  }

  async commitChanges (): Promise<void> {
    this.commitResults = []
    this.isCommitting = true
    await Promise.all(this.commitableChanges.map(async (entry: any) => {
      console.log(entry)
      const projectId = `gid://gitlab/Project/${entry.id}`
      // eslint-disable-next-line security/detect-object-injection
      const frameworkId = entry.newComplianceFramework?.id ?? null

      await this.$apollo.mutate({
        mutation: Mutations.APPLY_COMPLIANCE_FRAMEWORK,
        variables: {
          projectId,
          frameworkId
        },
        errorPolicy: 'all'
      }).then((result: any) => {
        const isSuccess = !result.errors || result.errors.length === 0
        this.commitResults.push({
          project: entry,
          isSuccess,
          errors: result.errors?.map((error: any) => error.message) ?? []
        })
        if (isSuccess) {
          this.updateProjectCache(entry.id, { compliance_frameworks: [entry.newComplianceFramework?.name ?? []] })
        }
      })
    }))
    this.isCommitting = false
  }

  mounted (): void {
    this.init()
  }

  init (): void {
    this.importedEntries = []
    this.rawProjectEntries = []
    this.projectsInScope = []
    this.rawFrameworkEntries = []
    this.rawProjectEntries = []
    this.commitResults = []
    this.loadingPreview = false
  }
}
</script>
